static char * sccsid = "@(#)  dump.c  (v5.1 8/31/89)";
/*
 * Dump various parts of the structures
 */

# include <stdio.h>
# include "kef.h"
# include <ctype.h>

extern struct kef ** kef_table;
extern int kef_size_db_table;

extern char * malloc ();
extern char * realloc ();
extern FREE_TYPE free ();

dump_kef (f, k)
	FILE * f;
	struct kef * k;
{
	fprintf (f, "Dump of kef structure at %1d\n", k);

	fprintf (f, "fd           = %3d (filedescriptor)\n", k->fd);
	fprintf (f, "delay        = %3s %4d\n",k->is_delay?"ON ":"OFF",k->delay);
	fprintf (f, "timeout      = %3s %4d\n",k->is_timeout?"ON ":"OFF",k->timeout);
	fprintf (f, "use_db       = %3s\n", k->use_db ? "yes" : "no ");
	fprintf (f, "buffer at    = %1d\n", k->buf);
	fprintf (f, "from at      = %1d offset %1d\n", k->from,
		(int)((char *)k->from - (char *)k->buf));
	fprintf (f, "cur at       = %1d offset %1d\n", k->cur,
		(int)((char *)k->cur - (char *)k->buf));
	fprintf (f, "to at        = %1d offset %1d\n", k->to,
		(int)((char *)k->to - (char *)k->buf));
	fprintf (f, "buf_end   at = %1d\n", k->buf_end);
	fprintf (f, "kef_db at    = %d\n", k->db);
	fprintf (f, "malloc       = %s\n", k->malloc == NULL ? "NULL":
		(k->malloc == malloc ? "malloc" : "some routine"));
	fprintf (f, "realloc      = %s\n", k->realloc == NULL ? "NULL":
		(k->realloc == realloc ? "realloc" : "some routine"));
	fprintf (f, "free         = %s\n", k->free == NULL ? "NULL":
		(k->free == free ? "free" : "some routine"));
	return KEF_E_OK;
}
