static char * sccsid = "@(#)  mcreate.c  (v2.10 4/17/90)";

/*
 * Create a kef structure and call _init to initialize it.
 */

# include <stdio.h>
# include "kef.h"

#ifdef DEBUG_CREATE
#	define L_DEBUG
#else
#	ifdef L_DEBUG
#		undef L_DEBUG
#	endif
#endif
# include "local.h"

	int
kef_mcreate (pk, buf, buf_size, kdb, fd, my_malloc, my_realloc, my_free)
	struct kef ** pk;
	byte * buf;
	int buf_size;
	struct kef_db * kdb;
	int fd;
	char * (* my_malloc) ();
	char * (* my_realloc)();
	FREE_TYPE (* my_free) ();
/*
 * Create an object of type kef with appendages.
 */
{
	DI("kef_create ::")
	register struct kef * k;
	byte * mybuf;

	DEB6("%s called with pk=%1d, buf=%1d, buf_size=%1d, kdb=%1d, fd=%1d\n",
		(int)pk, buf, buf_size, (int)kdb, fd);
	if (my_malloc == NULL)
		return KEF_E_NO_MALLOC;
	/*
	 * Allocate a new kef structure.
	 */
	k = (struct kef *) (* my_malloc) (sizeof (struct kef));
	if (k == NULL)
		return KEF_E_ALLOC_FAILED;

	if (buf == NULL) {
		/*
		 * Allocate buffer.
		 */
		if (buf_size == 0)
			buf_size = 512;
		mybuf = (byte *) (* my_malloc) (buf_size);
		if (mybuf == NULL)
			return KEF_E_ALLOC_FAILED;
	} else {
		if (buf_size <= 0)
			return KEF_E_INV_PAR;
		/*
		 * Use the parameter.
		 */
		mybuf = buf;
	}

	*pk = k;

	return
		kef__init (k, mybuf, buf_size, kdb, fd, my_malloc, my_realloc, my_free);
}
